searchNodes=[{"doc":"","ref":"Strukt.html","title":"Strukt","type":"behaviour"},{"doc":"See change/2","ref":"Strukt.html#c:change/1","title":"Strukt.change/1","type":"callback"},{"doc":"This callback can be overridden to provide custom change behavior. The default implementation provided for you creates a changeset and applies all of the inline validations defined on the schema. NOTE: It is recommended that if you need to perform custom validations, that you use the validation/1 and validation/2 facility for performing custom validations in a module or function, and if necessary, override validate/1 instead of performing validations in this callback. If you need to override this callback specifically for some reason, make sure you call super/2 at some point during your implementation to ensure that validations are run.","ref":"Strukt.html#c:change/2","title":"Strukt.change/2","type":"callback"},{"doc":"This variant of defstruct can accept a list of fields, just like Kernel.defstruct/1 , in which case it simply defers to Kernel.defstruct/1 and does nothing; or it can be passed a block containing an Ecto.Schema definition. The resulting struct/schema is defined in the current module scope, and will inherit attributes like @derive , @primary_key , etc., which are already defined in the current scope. Example defmodule Passthrough do use Strukt defstruct [ :name ] end defmodule Person do use Strukt @derive [ Jason.Encoder ] defstruct do field :name , :string end def say_hello ( % __MODULE__ { name : name } ) , do : &quot;Hello \#{ name } !&quot; end Above, even though Strukt.defstruct/1 is in scope, it simply passes through the list of fields to Kernel.defstruct/1 , as without a proper schema, there isn't much useful we can do. This allows intermixing uses of defstruct/1 in the same scope without conflict.","ref":"Strukt.html#defstruct/1","title":"Strukt.defstruct/1","type":"macro"},{"doc":"This variant of defstruct takes a module name and block containing a struct schema and any other module contents desired, and defines a new module with that name, generating a struct just like Strukt.defstruct/1 . Example use Strukt defstruct Person do @derive [ Jason.Encoder ] field :name , :string def say_hello ( % __MODULE__ { name : name } ) , do : &quot;Hello \#{ name } !&quot; end NOTE: Unlike Strukt.defstruct/1 , which inherits attributes like @derive or @primary_key from the surrounding scope; this macro requires them to be defined in the body, as shown above.","ref":"Strukt.html#defstruct/2","title":"Strukt.defstruct/2","type":"macro"},{"doc":"See new/1","ref":"Strukt.html#c:new/0","title":"Strukt.new/0","type":"callback"},{"doc":"This callback can be overridden to provide custom initialization behavior. The default implementation provided for you performs all of the necessary validation and autogeneration of fields with those options set. NOTE: It is critical that if you do override this callback, that you call super/1 to run the default implementation at some point in your implementation.","ref":"Strukt.html#c:new/1","title":"Strukt.new/1","type":"callback"},{"doc":"This callback can be overridden to manually implement your own validation logic. The default implementation handles invoking the validation rules expressed inline or via the validation/1 and validation/2 macros. You may still invoke the default validations from your own implementation using super/1 . This function can be called directly on a changeset, and is automatically invoked by the default new/1 and change/2 implementations.","ref":"Strukt.html#c:validate/1","title":"Strukt.validate/1","type":"callback"},{"doc":"Defines a validation rule for the current struct validation pipeline. A validation pipeline is constructed by expressing the rules in the order in which you want them applied, from top down. The validations may be defined anywhere in the module, but the order of application is always top down. You may define either module validators or function validators, much like Plug.Builder . For module validators, the module is expected to implement the Strukt.Validator behavior, consisting of the init/1 and validate/2 callbacks. For function validators, they are expected to be of arity 2. Both the validate/2 callback and function validators receive the changeset to validate/manipulate as their first argument, and options passed to the validation/2 macro, if provided. Guards Validation rules that should be applied conditionally can either handle the conditional logic in their implementation, or if simple, can use guards to express this instead, which can be more efficient. Guards may use the changeset being validated in their conditions by referring to changeset . See the example below to see how these can be expressed. Example defmodule Upload do use Strukt @allowed_content_types [ &quot;application/json&quot; , &quot;application/pdf&quot; , &quot;text/csv&quot; ] defstruct do field :filename , :string field :content , :binary , default : &lt;&lt; &gt;&gt; field :content_type , :string , required : true end # A simple function validator, expects a function in the same module validation :validate_filename # A function validator with a guard clause, only applied when the guard is successful validation :validate_content_type when is_map_key ( changeset . changes , :content_type ) # A module validator with options validation MyValidations.EnsureContentMatchesType , @allowed_content_types # A validator with options and a guard clause validation :example , [ foo : :bar ] when changeset . action == :update defp validate_filename ( changeset , _opts ) , do : changeset end","ref":"Strukt.html#validation/2","title":"Strukt.validation/2","type":"macro"},{"doc":"use Ecto.Schema's reflection to map the params.","ref":"Strukt.Params.html","title":"Strukt.Params","type":"module"},{"doc":"","ref":"Strukt.Params.html#transform/3","title":"Strukt.Params.transform/3","type":"function"},{"doc":"This module defines the behaviour for validator modules which can be used in validation pipelines over Strukt-defined structs.","ref":"Strukt.Validator.html","title":"Strukt.Validator","type":"behaviour"},{"doc":"This is called during validation to generate the options provided to validate/2 . The input is whatever was given as the second argument to Strukt.validation/2 , and any term is allowed to be returned. The return value will be passed as-is to the validate/2 callback.","ref":"Strukt.Validator.html#c:init/1","title":"Strukt.Validator.init/1","type":"callback"},{"doc":"Called during validation. The implementation is allowed to mutate the changeset as desired, but must return a new changeset regardless of whether the changeset it received was valid or not, but with relevant errors added.","ref":"Strukt.Validator.html#c:validate/2","title":"Strukt.Validator.validate/2","type":"callback"},{"doc":"","ref":"Strukt.Validator.html#t:opts/0","title":"Strukt.Validator.opts/0","type":"type"},{"doc":"This module compiles a validator pipeline. It is largely based on Plug.Builder , with minimal changes.","ref":"Strukt.Validator.Builder.html","title":"Strukt.Validator.Builder","type":"module"},{"doc":"Compiles the pipeline. Each pipeline element should be a tuple of {validator_name, options, guards} This function expects a reversed pipeline, i.e. the last validator to be called comes first in the list. This function returns a tuple where the first element is a quoted reference to the changeset being validated, and the second element being the compiled quoted pipeline. Example Strukt.Validator.Builder . compile ( env [ { Strukt.Validators.RequireOnInsert , [ :field ] , quote ( do : changeset . action == :insert ) , { Strukt.Validators.RequireOnUpdate , [ :other_field ] , quote ( do : changeset . action == :update ) } , { Strukt.Validators.RequireOnChange , [ :other_field ] , true } , ] , [ ] )","ref":"Strukt.Validator.Builder.html#compile/3","title":"Strukt.Validator.Builder.compile/3","type":"function"},{"doc":"This document details further how Strukt is implemented, and how to use it. Please report any issues on the issue tracker. Struct Definition There are two variants, depending on how you want to define your structs, Strukt.defstruct/1 and Strukt.defstruct/2 . The first is used to define a struct associated with the current module being defined: defmodule Person do use Strukt defstruct do field :name , :string , required : true end def name ( person ) , do : person . name end The second is used to define a struct and its module, inline: defmodule Entities do use Strukt defstruct Person do field :name , :string , required : true def name ( person ) , do : person . name end end The latter is generally useful only when you want to define multiple modules in the same file, which is probably relatively rare, but comes up from time to time, and this reduces the boilerplate a bit. Lastly, it is worth noting that embedded structs behave almost identically to Strukt.defstruct/2 : defmodule Company do use Strukt defstruct do field :name , :string , required : true embeds_many :employees , Employee do field :name , :string , required : true field :email , :string , required : true , format : ~r/^.+@.+$/ def name ( employee ) , do : employee . name end end end In the above, you'd end up with two modules, Company and Company.Employee . It's generally recommended to split up the definition of embedded structs, but in simple cases where the embedded type is strictly used only within the context of the containing type, it may be easier to keep the definitions together like this. Working with Structs The typical usage pattern for structs defined with Strukt more or less falls into one of the following buckets: Create a new struct, using the generated new/1 function, which returns {:ok, struct} or {:error, changeset} Given a struct, and a set of changes, apply them to the struct using change/2 , producing an Ecto.Changeset Given an Ecto.Changeset representing the struct, get back the struct using from_changeset/1 , which like new/1 , returns {:ok, struct} or {:error, changeset} Both new/1 and change/2 build on a common changeset function that performs casts for fields and embeds, and runs all of the validation rules, including custom ones defined in validate/1 . The primary difference between the two is that new/1 also performs autogeneration for fields (if applicable), and automatically invokes from_changeset/1 to get back the struct value. If you need to do custom initialization of your own, then you can override new/1 yourself, making sure that you invoke super(params) at some point to perform all of the standard initialization logic. For example, if you wanted to generate a primary key that is based on a hash of the contents of some fields of the struct, you might do something like this: defmodule Thing do use Strukt defstruct do # This overrides the default primary key to disable autogeneration field :uuid , Ecto.UUID , primary_key : true field :name , :string field :email , string end def new ( params \\\\ %{ } ) def new ( params ) do with { :ok , thing } &lt;- super ( params ) do hash = :crypto . hash_init ( :sha256 ) |&gt; :crypto . hash_update ( thing . name ) |&gt; :crypto . hash_update ( thing . email ) |&gt; :crypto . hash_final ( ) |&gt; Base . encode32 ( ) { :ok , % __MODULE__ { thing | uuid : UUID . uuid5 ( :oid , hash , :default ) } } end end end More Information You may also find the Schemas and JSON documents useful for answering more specific questions about those features.","ref":"usage.html","title":"Usage","type":"extras"},{"doc":"Strukt builds on Ecto.Schema , so much of what you need to know can be found in the Ecto docs . However, there are a few quality-of-life improvements implemented in Strukt that extend the schema syntax to allow for some additional functionality.","ref":"schemas.html","title":"Schemas","type":"extras"},{"doc":"The following is list of the changes we've made to the syntax provided by Ecto.Schema : Support for defining validations inline with the field definition, i.e. alongside standard options provided to field / embeds_one / embeds_many . Support for autogenerated fields with embedded_schema . Typically autogenerated fields in Ecto are intended to be provided by the database, but without a database in the loop, nothing happens. Since we're defining new/1 for the structs we define, it gives us an opportunity to ensure that the autogenerated fields get values immediately on struct creation. Support for defstruct 's extended functionality within embeds_one / embeds_many inline definitions, to any arbitrary nesting depth. One of the biggest quality-of-life improvements provided here is the ability to express validations inline with the field definition, as well as the automatic generation of validation code which is automatically applied when you call change/2 or changeset/2 . These build upon and operate on Ecto.Changeset , which is a powerful way of expressing constraints, and they compose well, especially when you have embeds involved.","ref":"schemas.html#schema-extensions","title":"Schemas - Schema Extensions","type":"extras"},{"doc":"Let's take a look at the use of inline validation rules, which you pass along with the standard options to macros like field/3 . The following validation options are provided: required: boolean | Keyword.t , options same as validate_required/3 length: Keyword.t , options same as validate_length/3 format: Keyword.t , options same as validate_format/4 one_of: list(term) | [values: list(term), message: String.t] , i.e. validate_inclusion/4 none_of: list(term) | [values: list(term), message: String.t] , i.e. validate_exclusion/4 subset_of: list(term) | [values: list(term), message: String.t] , i.e. validate_subset/4 range: Range.t | [value: Range.t, message: String.t] , i.e. validate_inclusion/4 number: Keyword.t , i.e. validate_number/4 In all of the above, you can provide a custom validation message using the keyword list variant, and setting :message to the desired format string. Custom Validations If you need to perform custom validation, or express conditional constraints, then you can override the definition of validate/1 , which takes an Ecto.Changeset on which you can apply arbitrary validation logic. This callback is also invoked any time you call new/1 , so be aware that if you need to conditionally apply validation rules, you will need to be able to determine the condition from the data the changeset is based on, see the Ecto.Changeset API if you aren't sure how to do that.","ref":"schemas.html#expressing-validations","title":"Schemas - Expressing Validations","type":"extras"},{"doc":"Support for JSON serialization is built upon Ecto.embedded_dump/2 , but must be explicitly enabled. This is to allow you to provide your own implementation if you don't desire to use the generated one. However, deriving the encoder is dead simple, and looks just like it would for any old struct. For example: # defstruct/1 defmodule Person do @derives [ Jason.Encoder ] defstruct do field :name , :string timestamps ( ) end end # defstruct/2 defstruct Person do @derives [ Jason.Encoder ] field :name , :string timestamps ( ) end Internally, defstruct provides a concrete implementation of Jason.Encoder that calls out to Ecto.embedded_dump/2 . For deserialization, from_json/1 is defined for the struct's module, and uses Ecto.embedded_load/3 to deserialize back to the original struct using the canonical deserializer for each field type. The difference versus just letting @derives [Jason.Encoder] do its thing, is that embedded_dump/2 and embedded_load/3 ensure that the types are dumped/loaded according to their respective Ecto type definitions, which should produce canonical JSON encodings, as opposed to naively encoding fields based on their raw Elixir representation. NOTE: Currently, we only implement special support for Jason.Encoder , if you use another JSON library, it is recommended that you implement the relevant encoder yourself using Ecto.embedded_dump/2 , much like we do for our implementation of Jason.Encoder .","ref":"json.html","title":"JSON Support","type":"extras"},{"doc":"Strukt provides an extended defstruct macro which builds on top of Ecto.Schema and Ecto.Changeset to remove the boilerplate of defining type specifications, implementing validations, generating changesets from parameters, JSON serialization, and support for autogenerated fields. This builds on top of Ecto embedded schemas, so the same familiar syntax you use today to define schema'd types in Ecto, can now be used to define structs for general purpose usage. The functionality provided by the defstruct macro in this module is strictly a superset of the functionality provided both by Kernel.defstruct/1 , as well as Ecto.Schema . If you import it in a scope where you use Kernel.defstruct/1 already, it will not interfere. Likewise, the support for defining validation rules inline with usage of field/3 , embeds_one/3 , etc., is strictly additive, and those additions are stripped from the AST before field/3 and friends ever see it.","ref":"readme.html","title":"About","type":"extras"},{"doc":"def deps do [ { :strukt , &quot;~&gt; 0.3&quot; } ] end","ref":"readme.html#installation","title":"About - Installation","type":"extras"},{"doc":"The following is an example of using defstruct/1 to define a struct with types, autogenerated primary key, and inline validation rules. defmodule Person do use Strukt @derives [ Jason.Encoder ] @primary_key { :uuid , Ecto.UUID , autogenerate : true } @timestamps_opts [ autogenerate : { NaiveDateTime , :utc_now , [ ] } ] defstruct do field :name , :string , required : true field :email , :string , format : ~r/^.+@.+$/ timestamps ( ) end end And an example of how you would create and use this struct: # Creating from params, with autogeneration of fields iex&gt; { :ok , person } = Person . new ( name : &quot;Paul&quot; , email : &quot;bitwalker@example.com&quot; ) ...&gt; person % Person { uuid : &quot;d420aa8a-9294-4977-8b00-bacf3789c702&quot; , name : &quot;Paul&quot; , email : &quot;bitwalker@example.com&quot; , inserted_at : ~N[2021-06-08 22:21:23.490554] , updated_at : ~N[2021-06-08 22:21:23.490554] } # Validation (Create) iex&gt; { :error , % Ecto.Changeset { valid? : false , errors : errors } } = Person . new ( email : &quot;bitwalker@example.com&quot; ) ...&gt; errors [ name : { &quot;can&#39;t be blank&quot; , [ validation : :required ] } ] # Validation (Update) iex&gt; { :ok , person } = Person . new ( name : &quot;Paul&quot; , email : &quot;bitwalker@example.com&quot; ) ...&gt; { :error , % Ecto.Changeset { valid? : false , errors : errors } } = Person . change ( person , email : &quot;foo&quot; ) ...&gt; errors [ email : { &quot;has invalid format&quot; , [ validation : :format ] } ] # JSON Serialization/Deserialization ...&gt; person == person |&gt; Jason . encode! ( ) |&gt; Person . from_json ( ) true","ref":"readme.html#example","title":"About - Example","type":"extras"},{"doc":"There are a few different ways to express and customize validation rules for a struct. Inline (as shown above, these consist of the common validations provided by Ecto.Changeset ) Validators (with module and function variants, as shown below) Custom (by overriding the validate/1 callback) The first two are the preferred method of expressing and controlling validation of a struct, but if for some reason you prefer a more manual approach, overriding the validate/1 callback is an option available to you and allows you to completely control validation of the struct. NOTE: Be aware that if you override validate/1 without calling super/1 at some point in your implementation, none of the inline or module/function validators will be run. It is expected that if you are overriding the implementation, you are either intentionally disabling that functionality, or are intending to delegate to it only in certain circumstances. Module Validators This is the primary method of implementing reusable validation rules: There are two callbacks, init/1 and validate/2 . You can choose to omit the implementation of init/1 and a default implementation will be provided for you. The default implementation returns whatever it is given as input. Whatever is returned by init/1 is given as the second argument to validate/2 . The validate/2 callback is required. defmodule MyValidator.ValidPhoneNumber do use Strukt.Validator @pattern ~r/^( \\+ 1 )[0-9]{3}-[0-9]{3}-[0-9]{4}$/ @impl true def init ( opts ) , do : Enum . into ( opts , %{ } ) @impl true def validate ( changeset , %{ fields : fields } ) do Enum . reduce ( fields , changeset , fn field , cs -&gt; case fetch_change ( cs , field ) do :error -&gt; cs { :ok , value } when value in [ nil , &quot;&quot; ] -&gt; add_error ( cs , field , &quot;phone number cannot be empty&quot; ) { :ok , value } when is_binary ( value ) -&gt; if value =~ @pattern do cs else add_error ( cs , field , &quot;invalid phone number&quot; ) end { :ok , _ } -&gt; add_error ( cs , field , &quot;expected phone number to be a string&quot; ) end end ) end end Function Validators These are useful for ad-hoc validators that are specific to a single struct and aren't likely to be useful in other contexts. The function is expected to received two arguments, the first is the changeset to be validated, the second any options passed to the validation/2 macro: defmodule File do use Strukt @allowed_content_types [ ] defstruct do field :filename , :string , required : true field :content_type , :string field :content , :binary end validation :validate_filename_matches_content_type , @allowed_content_types defp validate_filename_matches_content_type ( changeset , allowed ) do # ... end end As with module validators, the function should always return an Ecto.Changeset . Conditional Rules You may express validation rules that apply only conditionally using guard clauses. For example, extending the example above, we could validate that the filename and content type match only when either of those fields are changed: # With options validation :validate_filename_matches_content_type , @allowed_content_types when is_map_key ( changeset . changes , :filename ) or is_map_key ( changeset . changes , :content_type ) # Without options validation :validate_filename_matches_content_type when is_map_key ( changeset . changes , :filename ) or is_map_key ( changeset . changes , :content_type ) By default validation rules have an implicit guard of when true if one is not explicitly provided.","ref":"readme.html#validation","title":"About - Validation","type":"extras"},{"doc":"Using the :source option allows you to express that a given field may be provided as a parameter using a different naming scheme than is used in idiomatic Elixir code (i.e. snake case): defmodule Person do use Strukt @derives [ Jason.Encoder ] @primary_key { :uuid , Ecto.UUID , autogenerate : true } @timestamps_opts [ autogenerate : { NaiveDateTime , :utc_now , [ ] } ] defstruct do field :name , :string , required : true , source : :NAME field :email , :string , format : ~r/^.+@.+$/ timestamps ( ) end end # in iex iex&gt; { :ok , person } = Person . new ( %{ NAME : &quot;Ivan&quot; , email : &quot;ivan@example.com&quot; } ) ...&gt; person % Person { uuid : &quot;f8736f15-bfdc-49bd-ac78-9da514208464&quot; , name : &quot;Ivan&quot; , email : &quot;ivan@example.com&quot; , inserted_at : ~N[2021-06-08 22:21:23.490554] , updated_at : ~N[2021-06-08 22:21:23.490554] } NOTE: This does not affect serialization/deserialization via Jason.Encoder when derived. For more, see the usage docs","ref":"readme.html#custom-fields","title":"About - Custom Fields","type":"extras"},{"doc":"Apache License Version 2.0 , January 2004 http :// www . apache . org / licenses / TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License ; and (b) You must cause any modified files to carry prominent notices stating that You changed the files ; and (c) You must retain, in the Source form of any Derivative Works that You distribute , all copyright , patent , trademark , and attribution notices from the Source form of the Work , excluding those notices that do not pertain to any part of the Derivative Works ; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution , then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file , excluding those notices that do not pertain to any part of the Derivative Works , in at least one of the following places : within a NOTICE text file distributed as part of the Derivative Works ; within the Source form or documentation , if provided along with the Derivative Works ; or , within a display generated by the Derivative Works , if and wherever such third - party notices normally appear . The contents of the NOTICE file are for informational purposes only and do not modify the License . You may add Your own attribution notices within Derivative Works that You distribute , alongside or as an addendum to the NOTICE text from the Work , provided that such additional attribution notices cannot be construed as modifying the License . You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work , attach the following boilerplate notice , with the fields enclosed by brackets &quot;{}&quot; replaced with your own identifying information . ( Don &#39; t include the brackets! ) The text should be enclosed in the appropriate comment syntax for the file format . We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third - party archives . Copyright 2018 Paul Schoenfelder Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :// www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"}]